use std::ops::DerefMut;
use std::sync::Mutex;

use eframe::egui::{self};

use plate_tool_lib::plate::PlateFormat;

use crate::plate::{add_grid, PlateUiState};

pub struct PlateToolEframe {
    format: PlateFormat,
    source_plate_state: Mutex<PlateUiState>,
}

impl Default for PlateToolEframe {
    fn default() -> Self {
        Self {
            format: PlateFormat::W96,
            source_plate_state: Mutex::new(PlateUiState::default()),
        }
    }
}

impl PlateToolEframe {
    pub fn new(cc: &eframe::CreationContext<'_>) -> Self {
        // Would load state here

        Default::default()
    }
}

impl eframe::App for PlateToolEframe {
    // State storage
    /*
    fn save(&mut self, storage: &mut dyn eframe::Storage) {
        unimplemented!()
    };
    */

    fn update(&mut self, ctx: &eframe::egui::Context, _frame: &mut eframe::Frame) {
        egui::TopBottomPanel::top("top_panel").show(ctx, |ui| {
            ui.label("shrimp");
        });

        egui::CentralPanel::default().show(ctx, |ui| {
            ui.heading("lobster");
            add_grid(
                PlateFormat::W1536,
                ui,
                self.source_plate_state.lock().unwrap().deref_mut(),
            );
        });
    }
}
